-- Legal_Data_Script
merge	Taxonomy.LawType
	using	(
		select	DefaultLawType.Name as Name
			from	(
				values
				(N'material')
				,(N'procedural')
				,(N'instructional')
				) DefaultLawType (Name)
		) DefaultLawType
	on	DefaultLawType.Name = LawType.Name
	when not matched by target
		then
		insert	(
			Name
			)
			values	(
				DefaultLawType.Name
				)
;
go

begin
	with	LawCollection
	as
	(
	select	LawCollection.Name as Name
		,LawCollection.Title as Title
		,LawCollection.VersionNumber as VersionNumber
		,LawCollection.PublishedOn as PublishedOn
		,LawCollection.ValidSince as ValidSince
		,LawCollection.ValidUntil as ValidUntil
		,LawCollection.RuleText as RuleText
		,LawType.LawTypeId as LawTypeId
		from	(
			values
			(N'CrimCode', N'Criminal Code', 1, '19931008', '19940101', '19961231', N'(1) Whoever takes the life of another human being shall be sentenced to imprisonment for not less than five years.
(2) The perpetrator of the criminal offence under the preceding paragraph shall be sentenced to imprisonment for not less than ten years or to imprisonment for a term of twenty years if such a criminal offence has been committed:
1) in a cruel or perfidious manner;
2) out of greed, in order to commit or to conceal another criminal offence, out of unscrupulous vengeance, or from other base motives;
3) against an official or member of the military safeguarding public or state security, pursuing an offender or keeping a person in detention;
4) by two or more persons colluding, with the intention of committing murder.
(3) If the offence under the first paragraph of the present article has been committed in especially mitigating circumstances, the perpetrator shall be sentenced to imprisonment for not less than six months and not more than five years.', N'material')
			,(N'CrimCode', N'Criminal Code', 2, '19950923', '19970101', '20031231', N'(1) Whoever takes the life of another human being shall be sentenced to imprisonment for not less than five years.
(2) The perpetrator of the criminal offence under the preceding paragraph shall be sentenced to imprisonment for not less than ten years or to imprisonment for a term of thirty years if such a criminal offence has been committed:
1) in a cruel or perfidious manner;
2) out of greed, in order to commit or to conceal another criminal offence, out of unscrupulous vengeance, or from other base motives;
3) against an official or member of the military safeguarding public or state security, pursuing an offender or keeping a person in detention;
4) by two or more persons colluding, with the intention of committing murder.
(3) If the offence under the first paragraph of the present article has been committed in especially mitigating circumstances, the perpetrator shall be sentenced to imprisonment for not less than six months and not more than five years.', N'material')
			,(N'CrimCode', N'Criminal Code', 3, '20020407', '20040101', '20251231', N'(1) Whoever takes the life of another human being shall be sentenced to imprisonment for not less than seven years.
(2) The perpetrator of the criminal offence under the preceding paragraph shall be sentenced to imprisonment for not less than ten years or to imprisonment for a term of thirty years if such a criminal offence has been committed:
1) in a cruel or perfidious manner;
2) out of greed, in order to commit or to conceal another criminal offence, out of unscrupulous vengeance, or from other base motives;
3) against an official or member of the military safeguarding public or state security, pursuing an offender or keeping a person in detention;
4) by two or more persons colluding, with the intention of committing murder.
(3) If the offence under the first paragraph of the present article has been committed in especially mitigating circumstances, the perpetrator shall be sentenced to imprisonment for not less than six months and not more than seven years.', N'material')
			,(N'CrimCode', N'Criminal Code', 4, '20230606', '20260101', null, N'(1) Whoever takes the life of another human being shall be sentenced to imprisonment for not less than ten years.
(2) The perpetrator of the criminal offence under the preceding paragraph shall be sentenced to imprisonment for not less than twenty years or to imprisonment for a term of thirty years if such a criminal offence has been committed:
1) in a cruel or perfidious manner;
2) out of greed, in order to commit or to conceal another criminal offence, out of unscrupulous vengeance, or from other base motives;
3) against an official or member of the military safeguarding public or state security, pursuing an offender or keeping a person in detention;
4) by two or more persons colluding, with the intention of committing murder.
(3) If the offence under the first paragraph of the present article has been committed in especially mitigating circumstances, the perpetrator shall be sentenced to imprisonment for not less than six months and not more than seven years.', N'material')
			,(N'CrimProc', N'Criminal Procedure', 1, '19931008', '19940101', '19970630', N'(1) If the accused is deaf, dumb or otherwise incapable of defending himself successfully, or if criminal proceedings are conducted against the accused for a criminal offence punishable by thirty years of imprisonment, or if under Article 157 of this Act he is brought before an investigating judge, the accused shall have defence counsel from the very first interrogation.
(2) The accused shall be bound to have defence counsel in proceedings under Article 204a of this Act and for as long as he is subject to a detention order.
(3) The accused shall be bound to have defence counsel at the time the charge sheet is served on him if the law prescribes the punishment of five years imprisonment or a more severe punishment for the criminal offence he is charged with.
(4) If in the cases of mandatory defence referred to in the preceding paragraphs the accused fails to retain defence counsel by himself, the president of the court shall appoint defence counsel ex officio for the further course of criminal proceedings until the finality of the judgement; if the accused has been sentenced to thirty years in prison or is deaf, mute or otherwise incapable of successfully defending himself, he shall have defence counsel appointed for him for the extraordinary judicial review as well. If defence counsel is appointed ex officio after the charge sheet has been filed, the accused shall be informed thereof at the time the charge sheet is served on him. If in the case where defence is mandatory the accused remains without defence counsel, and fails to retain one by himself, the president of the court before which the proceedings are conducted shall appoint defence counsel ex officio.
(5) Only a lawyer may be appointed as defence counsel.', N'procedural')
			,(N'CrimProc', N'Criminal Procedure', 2, '19970515', '19970701', '20031231', N'(1) If the accused is deaf, dumb or otherwise incapable of defending himself successfully, or if criminal proceedings are conducted against the accused for a criminal offence punishable by thirty years of imprisonment, or if under Article 157 of this Act he is brought before an investigating judge, the accused shall have defence counsel from the very first interrogation.
(2) The accused shall be bound to have defence counsel in proceedings under Article 204a of this Act and for as long as he is subject to a detention order.
(3) The accused shall be bound to have defence counsel at the time the charge sheet is served on him if the law prescribes the punishment of eight years imprisonment or a more severe punishment for the criminal offence he is charged with.
(4) If in the cases of mandatory defence referred to in the preceding paragraphs the accused fails to retain defence counsel by himself, the president of the court shall appoint defence counsel ex officio for the further course of criminal proceedings until the finality of the judgement; if the accused has been sentenced to thirty years in prison or is deaf, mute or otherwise incapable of successfully defending himself, he shall have defence counsel appointed for him for the extraordinary judicial review as well. If defence counsel is appointed ex officio after the charge sheet has been filed, the accused shall be informed thereof at the time the charge sheet is served on him. If in the case where defence is mandatory the accused remains without defence counsel, and fails to retain one by himself, the president of the court before which the proceedings are conducted shall appoint defence counsel ex officio.
(5) Only a lawyer may be appointed as defence counsel.', N'procedural')
			,(N'CrimProc', N'Criminal Procedure', 3, '20030319', '20040101', null, N'(1) If the accused is deaf, dumb or otherwise incapable of defending himself successfully, or if criminal proceedings are conducted against the accused for a criminal offence punishable by thirty years of imprisonment, or if under Article 157 of this Act he is brought before an investigating judge, the accused shall have defence counsel from the very first interrogation.
(2) The accused shall be bound to have defence counsel in proceedings under Article 204a of this Act and for as long as he is subject to a detention order.
(3) The accused shall be bound to have defence counsel at the time the charge sheet is served on him if the law prescribes the punishment of ten years imprisonment or a more severe punishment for the criminal offence he is charged with.
(4) If in the cases of mandatory defence referred to in the preceding paragraphs the accused fails to retain defence counsel by himself, the president of the court shall appoint defence counsel ex officio for the further course of criminal proceedings until the finality of the judgement; if the accused has been sentenced to thirty years in prison or is deaf, mute or otherwise incapable of successfully defending himself, he shall have defence counsel appointed for him for the extraordinary judicial review as well. If defence counsel is appointed ex officio after the charge sheet has been filed, the accused shall be informed thereof at the time the charge sheet is served on him. If in the case where defence is mandatory the accused remains without defence counsel, and fails to retain one by himself, the president of the court before which the proceedings are conducted shall appoint defence counsel ex officio.
(5) Only a lawyer may be appointed as defence counsel.', N'procedural')
			) LawCollection (Name, Title, VersionNumber, PublishedOn, ValidSince, ValidUntil, RuleText, LawTypeName)
			inner join	Taxonomy.LawType
					on	LawType.Name = LawCollection.LawTypeName
	)
	merge	Document.Law
		using	LawCollection
		on	(LawCollection.Name = Law.Name)
			and (LawCollection.VersionNumber = Law.VersionNumber)
		when matched
			and (Law.Title != LawCollection.Title
				or Law.PublishedOn != LawCollection.PublishedOn
				or Law.ValidSince != LawCollection.ValidSince
				or Law.ValidUntil != LawCollection.ValidUntil
				or Law.RuleText != LawCollection.RuleText
				or Law.LawTypeId != LawCollection.LawTypeId)
			then
			update	set	Law.Title = LawCollection.Title
					,Law.PublishedOn = LawCollection.PublishedOn
					,Law.ValidSince = LawCollection.ValidSince
					,Law.ValidUntil = LawCollection.ValidUntil
					,Law.RuleText = LawCollection.RuleText
					,Law.LawTypeId = LawCollection.LawTypeId
		when not matched by target
			then
			insert	(
				Name
				,Title
				,VersionNumber
				,PublishedOn
				,ValidSince
				,ValidUntil
				,RuleText
				,LawTypeId
				)
				values	(
					LawCollection.Name
					,LawCollection.Title
					,LawCollection.VersionNumber
					,LawCollection.PublishedOn
					,LawCollection.ValidSince
					,LawCollection.ValidUntil
					,LawCollection.RuleText
					,LawCollection.LawTypeId
					)
		when not matched by source
			then
			delete
	;
end
go

begin
	with	FactCollection
	as
	(
	select	FactCollection.CaseNumber as CaseNumber
		,FactCollection.CaseYear as CaseYear
		,FactCollection.Name as Name
		,FactCollection.Abstract as Abstract
		,FactCollection.RelevantSince as RelevantSince
		,FactCollection.RelevantUntil as RelevantUntil
		,LawType.LawTypeId as RelevantLawTypeId
		from	(
			values
			(278, 1999, N'murder', N'David shot John dead.', cast('19940603' as date), cast('19940603' as date), N'material')
			,(278, 1999, N'plea', N'Plea hearing.', cast('19991105' as date), cast('19991105' as date), N'procedural')
			,(278, 1999, N'trial', N'Criminal trial.', cast('20000105' as date), cast('20011026' as date), N'procedural')
			,(278, 1999, N'sentence', N'Criminal sentencing.', cast('20011103' as date), cast('20011103' as date), N'procedural')
			,(23, 2003, N'murder', N'Maggie shot Mr. Burns dead.', cast('19951103' as date), cast('19951103' as date), N'material')
			,(23, 2003, N'plea', N'Plea hearing.', cast('20030612' as date), cast('20030614' as date), N'procedural')
			,(23, 2003, N'trial', N'Criminal trial.', cast('20031106' as date), cast('20040324' as date), N'procedural')
			,(23, 2003, N'sentence', N'Criminal sentencing.', cast('20040402' as date), cast('20040402' as date), N'procedural')
			,(551, 2005, N'murder', N'Ted went on a rampage.', cast('19951103' as date), cast('19951103' as date), N'material')
			,(551, 2005, N'plea', N'Plea hearing.', cast('20050905' as date), cast('20050905' as date), N'procedural')
			,(551, 2005, N'trial', N'Criminal trial.', cast('20060105' as date), null, N'procedural')
			) FactCollection (CaseNumber, CaseYear, Name, Abstract, RelevantSince, RelevantUntil, RelevantLawTypeName)
			inner join	Taxonomy.LawType
					on	LawType.Name = FactCollection.RelevantLawTypeName
	)
	merge	Document.Fact
		using	FactCollection
		on	(FactCollection.CaseNumber = Fact.CaseNumber)
			and (FactCollection.CaseYear = Fact.CaseYear)
			and (FactCollection.Name = Fact.Name)
			and (FactCollection.RelevantSince = Fact.RelevantSince)
			and (FactCollection.RelevantUntil = Fact.RelevantUntil)
		when matched
			and (Fact.Abstract != FactCollection.Abstract
				or Fact.RelevantLawTypeId != FactCollection.RelevantLawTypeId)
			then
			update	set	Fact.Abstract = FactCollection.Abstract
					,Fact.RelevantLawTypeId = FactCollection.RelevantLawTypeId
		when not matched by target
			then
			insert	(
				CaseNumber
				,CaseYear
				,Name
				,Abstract
				,RelevantSince
				,RelevantUntil
				,RelevantLawTypeId
				)
				values	(
					FactCollection.CaseNumber
					,FactCollection.CaseYear
					,FactCollection.Name
					,FactCollection.Abstract
					,FactCollection.RelevantSince
					,FactCollection.RelevantUntil
					,FactCollection.RelevantLawTypeId
					)
		when not matched by source
			then
			delete
	;
end
go
